package com.fuzamei.service;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.fuzamei.dao.OperationHistoryDao;
import com.fuzamei.entity.OperationHistory;
import com.fuzamei.utils.DateUtil;
import com.fuzamei.utils.PageDTO;

@Service
public class OperationHistoryService {

	@Autowired
	private OperationHistoryDao operationHistoryDao;

	private static final int ROW_NUM = 10; // 分页每页显示数据的数量

	/**
	 * 
	 * @Title: queryOperationHistoryInformation @Description:
	 * TODO(从dao层查询出分页数据信息) @param @param page @param @param
	 * account @param @param role @param @param type @param @param
	 * startTime @param @param endTime @param @return 设定文件 @return PageDTO
	 * 返回类型 @author ylx @date 2017年12月14日 下午8:09:43 @throws
	 */
	public PageDTO queryOperationHistoryInformation(Map<String, Object> map) {
		int page = 1; // 默认页是第一页
		String account = ""; // 账号默认空值
		String role = ""; // 操作角色默认空值
		String type = ""; // 操作类型默认空值
		long startTime = 0; // 开始时间默认0
		long endTime = Long.MAX_VALUE; // 结束时间默认Long最大值
		if (!"".equals(map.get("page")) && map.get("page") != null) { 							// 等于空就直接取第一页
			try {
				page = Integer.parseInt((String) map.get("page"));
				if (page < 1) {
					page = 1;
				}
			} catch (Exception e) {
				page = 1; // 数据解析异常page还是1
			}
		}
		if (!"".equals(map.get("account")) && map.get("account") != null) { 						// 等于空就直接取空值
			try {
				account = (String) map.get("account");
			} catch (Exception e) {
				account="";
			}
		}
		if (!"".equals(map.get("role")) && map.get("role") != null) { // 等于空就直接取空值
			try {
				role = (String) map.get("role");
			} catch (Exception e) {
				role="";
			}
		}
		if (!"".equals(map.get("type")) && map.get("type") != null) { // 等于空就直接取空值
			try {
				type = (String) map.get("type");
			} catch (Exception e) {
				type="";
			}
		}
		if (!"".equals(map.get("startTime")) && map.get("startTime") != null) { // 等于空就直接取空值
			try {
				startTime = Long.parseLong((String) map.get("startTime"));
			} catch (Exception e) {
				startTime = 0; // 数据解析异常或转换类型异常startTime还是0
			}
		}
		if (!"".equals(map.get("endTime")) && map.get("endTime") != null) { // 等于空就直接取空值
			try {
				endTime = Long.parseLong((String) map.get("endTime"));
			} catch (Exception e) {
				endTime = Long.MAX_VALUE; // 数据解析异常或转换类型异常endTime还是9223372036854775807L
			}
		}
		PageDTO pageDto = new PageDTO(); // 创建分页对象
		Map<String, Object> mapToDao = new LinkedHashMap<String, Object>();
		mapToDao.put("startPage", (page - 1) * ROW_NUM);
		mapToDao.put("account", account);
		mapToDao.put("role", role);
		mapToDao.put("type", type);
		if (startTime <= endTime) {
			mapToDao.put("startTime", startTime);
			mapToDao.put("endTime", endTime);
		} else {
			mapToDao.put("startTime", startTime);
			mapToDao.put("endTime", Long.MAX_VALUE);
		}
		mapToDao.put("rowNum", ROW_NUM); //默认每页显示数据是10条，可根据需求修改分页数量

		List<OperationHistory> informationList = operationHistoryDao.queryOperationHistoryInformation(mapToDao); // 去dao层取分页的数据

		int count = operationHistoryDao.findAllInformation();
		pageDto.setTotal(count);
		pageDto.setRows(informationList);
		return pageDto;
	}

}
