package com.fuzamei.web;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.fuzamei.service.AccountOpenService;
import com.fuzamei.utils.JSONUtil;
import com.fuzamei.utils.PageDTO;

@Controller
@RequestMapping(value = "/Account")
public class AccountOpenAction {
	

	@Autowired
	private AccountOpenService  accountService;//注入service

	@RequestMapping(value = "/queryAccountInfo", method = RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> queryAccountInfo(@RequestBody String data) {
		//System.out.println("查询账户开立信息列表");
		Map<String, Object> mapResult = new LinkedHashMap<String, Object>();
		Map<String, Object> map = JSONUtil.jsonToMap(data);
		PageDTO pageDto=  accountService.queryAllAccountOpening(map);
		mapResult = JSONUtil.getJsonMap(200, true, "操作成功", pageDto);

		return mapResult;
	}
	
	@RequestMapping(value = "/selectPromptLetter", method = RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> selectPromptLetter(@RequestBody String data) {
		//System.out.println("查询风险提示函信息列表");
		Map<String, Object> mapResult = new LinkedHashMap<String, Object>();
		Map<String, Object> map = JSONUtil.jsonToMap(data);
		PageDTO pageDto=  accountService.selectPromptLetter(map);
		mapResult = JSONUtil.getJsonMap(200, true, "操作成功", pageDto);

		return mapResult;
	}
	

	@RequestMapping(value = "/selectTishihan", method = RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> selectTishihan(@RequestBody String data) {
		//System.out.println("查询风险提示函信息列表3 ，省分行托管中心风管岗");
		Map<String, Object> mapResult = new LinkedHashMap<String, Object>();
		Map<String, Object> map = JSONUtil.jsonToMap(data);
		PageDTO pageDto=  accountService.selectTishihan(map);
		mapResult = JSONUtil.getJsonMap(200, true, "操作成功", pageDto);

		return mapResult;
	}
	
	
	 /**  
     *  添加客户名称和银行账号  上传资料
     * @param  
     * @param   
     * @throws Exception  
     */
    @RequestMapping(value="/uploadOrInsertBankAccount",method=RequestMethod.POST)  
    @ResponseBody  
    public Map<String,Object> uploadOrInsertBankAccount(@RequestParam("basic_data_id") MultipartFile file,@RequestParam("letter_of_commitment_id") MultipartFile file2 ,
    		@RequestParam("application_id") MultipartFile file3, HttpServletRequest request,
    	    @RequestParam("customer_name") String customer_name,
    	    @RequestParam("bank_account") String bank_account) throws IOException{
    	try {
    		String path = "D:\\tomcate\\apache-tomcat-8.5.24\\webapps"+request.getServletContext().getContextPath()+"\\testCeshi";  
            //String fileName = file.getOriginalFilename();    
              File dir = new File(path);          
              if(!dir.exists()){  
                  dir.mkdirs();   
              }  
          Map<String, Object> map = new LinkedHashMap<String, Object>();
             map.put("customer_name", customer_name);  
             map.put("bank_account", bank_account);//可以不要  不输入参数   直接在service里put进去
     
		    
            //基本资料 
            String fileName = file.getOriginalFilename();  
            String pathFile=path+"/"+fileName;
            File newfile = new File(pathFile); 
            file.transferTo(newfile);
            map.put("basicAttachment_id", 333);//附件id暂时写死
    		map.put("basicAttachment_name", fileName);
    	    map.put("basicUrl","\\testCeshi"+fileName);
    	    
    	    //账户承诺书
    	    String fileName2 = file2.getOriginalFilename();  
            String pathFile2=path+"/"+fileName2;
            File newfile2 = new File(pathFile2); 
            file2.transferTo(newfile2);
            map.put("letterAttachment_id", 444);//附件id暂时写死
    		map.put("letterAttachment_name", fileName2);
    	    map.put("letterUrl","\\testCeshi"+fileName2);
    	    
    	    //开户申请书
       	    String fileName3 = file3.getOriginalFilename();  
            String pathFile3=path+"/"+fileName3;
            File newfile3 = new File(pathFile3); 
            file3.transferTo(newfile3);
            map.put("applicationAttachment_id", 555);//附件id暂时写死
    		map.put("applicationAttachment_name", fileName3);
    	    map.put("applicationUrl","\\testCeshi"+fileName3);
            
    	    accountService.insertAccountUploadFile(map);
    	 
    	    Map<String, Object> mapResult=JSONUtil.getJsonMap(500, true, "上传成功了", null);
              return mapResult;
		 } catch (Exception e) {
			Map<String, Object> mapResult=JSONUtil.getJsonMap(500, true, "上传失败"+e.getMessage(), null);
			return mapResult ;
		 }
    	
    	
    	
    	
    }
	
	
	
	
	
	
	
	   
}
	

