package com.fuzamei.web;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Scanner;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import com.fuzamei.service.OperationHistoryService;
import com.fuzamei.utils.JSONUtil;
import com.fuzamei.utils.PageDTO;


@Controller
@RequestMapping("/operation_history")
public class OperationHistoryAction {

	@Autowired
	private OperationHistoryService operationHistoryService;
	
	/**
	 * 
	* @Title: queryOperationHistoryInformation
	* @Description: TODO(查询操作记录信息....)
	* @param @param data--前台传递过来的application/json数据
	* 				传递过来的参数json格式为：
					{
						"page":"1",			
						"account":"",
						"role":"",
						"type":"",
						"startTime":"",
						"endTime":""
					}
	* @param @return    返回json格式
	* @return Map<String,Object>    返回类型
	* @author ylx
	* @date 2017年12月14日 下午5:12:17
	* @throws
	 */
	@RequestMapping(value="/queryOperationHistoryInformation",method=RequestMethod.POST)
	@ResponseBody
	public Map<String,Object> queryOperationHistoryInformation(@RequestBody String data){
		
		System.out.println("查询操作记录信息....");
		
		Map<String, Object> map = JSONUtil.jsonToMap(data);		//将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
		
		PageDTO pageDto = operationHistoryService.queryOperationHistoryInformation(map);
		
		return JSONUtil.getJsonMap(200, true, "操作成功", pageDto);
	}
	
	
	
	/*//算数据库中bigint的时间用的
	public static void main(String[] args) throws ParseException {
		SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
		Scanner scan=new Scanner(System.in);
		while(true){
		String str=scan.next();
		Date parse = sdf.parse(str);
		System.out.println(parse.getTime());
		}
		
	}*/
	
	/*public static void main(String[] args) {
		System.out.println(Long.MAX_VALUE);
		System.out.println(Integer.parseInt("1.1"));
	}*/
}
