package com.fuzamei.web;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URLEncoder;
import java.security.MessageDigest;
import java.util.LinkedHashMap;
import java.util.Map;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.util.DigestUtils;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import com.fuzamei.service.AccountOpenService;
import com.fuzamei.theromus.utils.HexUtils;
import com.fuzamei.utils.HashCodeUtil;
import com.fuzamei.utils.HashXiZhiUtil;
import com.fuzamei.utils.JSONUtil;
/**  
 * 文件上传功能  
 * @param file  
 * @return  
 * @throws IOException   
 */  
@Controller
@RequestMapping(value = "/PromptLetter")
public class PromptLetterAction {
	@Autowired
	private AccountOpenService  accountService;//注入service
	
  /*  @RequestMapping(value="/upload",method=RequestMethod.POST)  
    @ResponseBody  
    public Map<String,Object> upload(@RequestParam("file") MultipartFile file,HttpServletRequest request) throws IOException{  
        String path = "D:\\tomcate\\apache-tomcat-8.5.24\\webapps"+request.getServletContext().getContextPath()+"\\UploadCeshi";  
        String fileName = file.getOriginalFilename();    
        File dir = new File(path+"/"+fileName);          
        if(!dir.exists()){  
            dir.mkdirs();  
        }  
        //MultipartFile自带的解析方法  
        file.transferTo(dir);  
    	Map<String, Object> mapResult=JSONUtil.getJsonMap(200, true, "上传成功", null);//将查询出来的结果封装成map数据返回
         return mapResult ;
         
    }  */
	   /**  
     * 文件下载功能  
     * @param request  
     * @param response  
     * @throws Exception  
     */  
/*    @RequestMapping("/down")  
    public void down(HttpServletRequest request,HttpServletResponse response) throws Exception{  
        //模拟文件，aa.txt为需要下载的文件  
        String fileName = request.getSession().getServletContext().getRealPath("upload")+"/aa.txt";  
        //获取输入流  
        InputStream bis = new BufferedInputStream(new FileInputStream(new File(fileName)));  
        //假如以中文名下载的话  
        String filename = "下载文件.txt";  
        //转码，免得文件名中文乱码  
        filename = URLEncoder.encode(filename,"UTF-8");  
        //设置文件下载头  
        response.addHeader("Content-Disposition", "attachment;filename=" + filename);    
        //1.设置文件ContentType类型，这样设置，会自动判断下载文件类型    
        response.setContentType("multipart/form-data");   
        BufferedOutputStream out = new BufferedOutputStream(response.getOutputStream());  
        int len = 0;  
        while((len = bis.read()) != -1){  
            out.write(len);  
            out.flush();  
        }  
        out.close();  
    } */
	/**
	 * 风险提示函发函  上传
	 * @param file
	 * @param request
	 * @param prompt_letter_id
	 * @return
	 * @throws IOException
	 */
	    @RequestMapping(value="/uploadFile",method=RequestMethod.POST)  
	    @ResponseBody  
	    public Map<String,Object> upload(@RequestParam("file") MultipartFile file,HttpServletRequest request,@RequestParam("prompt_letter_id") String prompt_letter_id) throws IOException{  
	        try {
	        	String path = "D:\\tomcate\\apache-tomcat-8.5.24\\webapps"+request.getServletContext().getContextPath()+"\\UploadCeshi";  
	            File dir = new File(path);          
	            if(!dir.exists()){  
	                dir.mkdirs();  
	            } 
	            String fileName = file.getOriginalFilename();  
	            String pathFile=path+"/"+fileName;
	            File newfile = new File(pathFile); 
	            file.transferTo(newfile);
	            //MultipartFile自带的解析方法 
	    		Map<String, Object> map = new LinkedHashMap<String, Object>();
	    		map.put("prompt_letter_id", prompt_letter_id);//有问题   待改动   ， 这里应该是管理人账号   这里只插入了一个账号到提示函表 别的字段没写，问清楚了在改
	    		
	    		map.put("fileName", fileName);
	    		map.put("url",fileName);
	            accountService.insertTiShiHanOrUser(map);
	            
	            Map<String, Object>	mapResult=JSONUtil.getJsonMap(200, true, "上传提示函成功", null);
				return mapResult ;
			}
	       catch (Exception e) {
				Map<String, Object> mapResult=JSONUtil.getJsonMap(500, true, "上传提示函失败"+e.getMessage(), null);
				return mapResult;
			}
		
	    	
	    }  
	
    /**  
     * 账户开立下载 doc文档
     * @param request  
     * @param response  
     * @throws Exception  
     */  
    @RequestMapping(value="/downloadFile")  
    @ResponseBody 
    public Map<String,Object> downloadFile(HttpServletRequest request,HttpServletResponse response,@RequestParam("url") String url) throws Exception{  
        try {
        	  //模拟文件，456.doc为需要下载的文件  
            String fileName = request.getSession().getServletContext().getRealPath("")+url;  
            //获取输入流  
            InputStream bis = new BufferedInputStream(new FileInputStream(new File(fileName))); 
            //截取文件名字
            String filename = url.substring(url.lastIndexOf("/")+1);
            //转码，免得文件名中文乱码  
            filename = URLEncoder.encode(filename,"UTF-8");  
            //设置文件下载头  
            response.addHeader("Content-Disposition", "attachment;filename=" + filename);    
            //1.设置文件ContentType类型，这样设置，会自动判断下载文件类型    
            response.setContentType("multipart/form-data");   
            BufferedOutputStream out = new BufferedOutputStream(response.getOutputStream());  
            int len = 0;  
            while((len = bis.read()) != -1){  
                out.write(len);  
                out.flush();  
            }  
            out.close(); 
            //返给前端map进行前端提示
        	return JSONUtil.getJsonMap(200, true, "下载成功",null); 
			
		} catch (Exception e) {
			return JSONUtil.getJsonMap(500, false, "下载失败:"+e.getMessage(),null); 
		}
	
    	 
    } 
    
    /**  
     * 真伪查询 上传文件  产生一条哈希值
     * @param  
     * @param   
     * @throws Exception  
     */  
    @RequestMapping(value="/trueFalseSelect",method=RequestMethod.POST)  
    @ResponseBody  
    public Map<String,Object> trueFalseSelect(@RequestParam("file") MultipartFile file,HttpServletRequest request) throws IOException{  
       try {
    	   String path = "D:\\tomcate\\apache-tomcat-8.5.24\\webapps"+request.getServletContext().getContextPath()+"\\Ceshi";  
           File dir = new File(path);          
           if(!dir.exists()){  
               dir.mkdirs();  
           }  
           //MultipartFile自带的解析方法  
           
           String fileName = file.getOriginalFilename();  
           String pathFile=path+"/"+fileName;
           File newfile = new File(pathFile); 
           file.transferTo(newfile);
           //MultipartFile自带的解析方法 
   		   Map<String, Object> map = new LinkedHashMap<String, Object>();
   		   map.put("fileName", fileName);
   		   map.put("url",fileName);
           
           accountService.insertTrueFalseSelect(map);
           //上传文件之后才会产生一条哈希值的
          // HashXiZhiUtil.getMd5("D:\\xiangnu\\123.doc");
           HashXiZhiUtil.getMD5Checksum(pathFile);//调用方法 对（文件）产生一条哈希值
        System.out.println( HashXiZhiUtil.getMD5Checksum(pathFile)+"--哈希值");//自己测试的
       	Map<String, Object> mapResult=JSONUtil.getJsonMap(200, true, "上传成功", null);//将查询出来的结果封装成map数据返回
            return mapResult ;
		}
       catch (Exception e) {
			Map<String, Object> mapResult=JSONUtil.getJsonMap(500, true, "上传失败"+e.getMessage(), null);
			return mapResult ;
		}
    }  
    

 
	
}
